RECSIZE=80;BLOCKFACTOR=51;CODE=1052;EXTENTS=9;FILESIZE=361;ASCII;FORMAT=F001000$TITLE "QSDK-QSS Server Developer's Kit- QCSMPE A.02.00 06/15/96" 20 SEP95001100 IDENTIFICATION DIVISION.                                                 001200 PROGRAM-ID. QCSMPE.                                                      001300 DATE-WRITTEN. JUNE 1995.                                                 001400 DATE-COMPILED.                                                           001500 AUTHOR. QSS.                                                             001600 INSTALLATION. QSS.                                                       001700*****************************************************************         001800*   NAME: CSMPE.                                                *         001900*VERSION: A.02.00.                                              * 20 SEP95002000* SYSTEM: QSS Server Developer Kit.                             *         002100*   DATE: June 1995.                                            *         002200* AUTHOR: Duane Percox                                          *         002300*COMMENT: This is the server program for C/S MPE. This code is  *         002400*         launched by a listener (qlisten)  when a pc/client    *         002500*         makes a connection.  This server provides basic mpe   *         002600*         services to a client pc without the pc needing to be  *         002700*         logged into the hp3k. Only certain commands can be    *         002800*         used and they are non-destructive so we can avoid     *         002900*         the issue of security. Run this from a job which is   *         003000*         logged into an account that offers the access your are*         003100*         willing to offer the client. Basically, any command   *         003200*         that supports redirection ('cmd' > ...) will work the *         003300*         way this is written. Notice that the connection is    *         003400*         maintained and not dropped after each command. If you * 20 SEP95003500*         were using this as a production server you might want * 20 SEP95003600*         to modify this behavior.                              * 20 SEP95003700*                                                               * 20 SEP95003800*HISTORY:                                                       *         003900*                                                               *         004000*06/09/95 DAP(I) A.00.00 Initial coding                         *         004100*06/16/96 DAP(M) A.02.00 QSDK A.02.xx release.                  * 20 SEP95004200*****************************************************************         004300 ENVIRONMENT DIVISION.                                                    004400 CONFIGURATION SECTION.                                                   004500 SOURCE-COMPUTER. HP-3000-MPE.                                            004600 OBJECT-COMPUTER. HP-3000-MPE.                                            004700 INPUT-OUTPUT SECTION.                                                    004800 FILE-CONTROL.                                                            004900     SELECT RESULT-FILE ASSIGN USING WS-RESULT-FILE.                      005000*****************************************************************         005100*                                                               *         005200* COPYRIGHT (C) 1995-1996 QUINTESSENTIAL SCHOOL SYSTEMS.        *         005300*                                                               *         005400* THIS SOFTWARE IS FURNISHED UNDER A LICENSE FOR USE ONLY       *         005500* ON A SINGLE COMPUTER SYSTEM. THIS SOFTWARE, OR ANY COPIES     *         005600* THEREOF, IN ANY FORM, INCLUDING BUT NOT LIMITED TO HARDCOPY,  *         005700* MACHINE READABLE IN ANY FORM, MICROFILM OR MICROFICHE,        *         005800* MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY        *         005900* OTHER PERSON EXCEPT FOR USE ON SUCH SYSTEM AND TO ONE WHO     *         006000* AGREES TO THESE LICENSE TERMS. TITLE TO AND OWNERSHIP OF THIS *         006100* SOFTWARE SHALL AT ALL TIMES BELONG TO QSS.                    *         006200* THE INFORMATION IN THIS DOCUMENT IS SUBJECT TO CHANGE WITHOUT *         006300* NOTICE AND SHOULD NOT BE CONSTRUED AS A COMMITMENT BY         *         006400* QSS.                                                          *         006500*                                                               *         006600*****************************************************************         006700$PAGE                                                                     006800 DATA DIVISION.                                                           006900 FILE SECTION.                                                            007000 FD  RESULT-FILE.                                                         007100                                                                          007200 01  RF-TEXT                          PIC X(80).                          007300$PAGE                                                                     007400 WORKING-STORAGE SECTION.                                                 007500 01  VERSION-DISPLAY.                                             20 SEP95007600     03  PROG-NAME                    PIC X(08) VALUE "QCSMPE".   20 SEP95007700     03  FILLER                       PIC X(02) VALUE SPACES.     20 SEP95007800     03  PROG-VERSION                 PIC X(07) VALUE "A.02.00".  20 SEP95007900     03  FILLER                       PIC X(10) VALUE             20 SEP95008000         " compiled ".                                            20 SEP95008100     03  PROG-COMPILED                PIC X(08) VALUE "99/99/99". 20 SEP95008200                                                                  20 SEP95008300 01  WS-DISPLAY-16                    PIC ZZZZ9-.                         008400 01  WS-DISPLAY-32                    PIC Z(8)9-.                         008500                                                                          008600 01  I                                PIC S9(4) COMP.                     008700                                                                          008800 01  EOF-CONNECTION-FLAG              PIC X VALUE "N".                    008900     88  EOF-CONNECTION               VALUE "Y".                          009000 01  HAVE-CONNECTION-FLAG             PIC X VALUE "N".                    009100     88  HAVE-CONNECTION              VALUE "Y".                          009200                                                                          009300 01  WS-RT-PARMS.                                                         009400     03  READ-X-LEN                   PIC S9(9) COMP VALUE ZERO.          009500     03  READ-X-MAX                   PIC S9(9) COMP VALUE 2048.          009600     03  WS-TRAN-DEF.                                                     009700         05  FILLER                   PIC X VALUE %1.                     009800         05  FILLER                   PIC X(3) VALUE SPACES.              009900         05  FILLER                   PIC X VALUE %2.                     010000         05  FILLER                   PIC X(3) VALUE SPACES.              010100     03  READ-X-BUFFER                PIC X(2048) VALUE SPACES.           010200                                                                          010300 01  WS-NAME-BASE                     PIC X(08) VALUE "TEMP".             010400 01  MY-PIN                           PIC S9(9) COMP VALUE ZERO.          010500 01  DAD-PIN                          PIC S9(9) COMP VALUE ZERO.  20 SEP95010600 01  SD-SOCKET                        PIC S9(9) COMP VALUE ZERO.          010700                                                                          010800 01  WS-ERR-STATUS.                                                       010900     03  WS-ERR-CODE                  PIC S9(9) COMP.                     011000     03  WS-ERR-LL                    PIC S9(9) COMP.                     011100     03  WS-ERR-LL-ID                 PIC S9(9) COMP.                     011200                                                                          011300 01  READ-ACTUAL                      PIC S9(9) COMP.                     011400 01  RW-BUFFER                        PIC X(2048).                        011500 01  WRITE-LEN                        PIC S9(9) COMP.                     011600 01  WS-WRITE-COUNT                   PIC S9(9) COMP.                     011700 01  WS-LINE-LEN                      PIC S9(4) COMP.                     011800                                                                          011900 01  EOF-RESULT-FLAG                  PIC X VALUE "N".                    012000     88  EOF-RESULT                   VALUE "Y".                          012100 01  EOL-FLAG                         PIC X VALUE "N".                    012200     88  EOL                          VALUE "Y".                          012300                                                                          012400 01  WS-RESULT-FILE.                                                      012500     03  FILLER                       PIC X(02) VALUE "RF".               012600     03  WS-PIN                       PIC 9(5).                           012700                                                                          012800 01  WS-OPTIONAL-PARMS.                                                   012900     03  WS-OPT-FLAGS.                                                    013000         05  WS-OPT-FLAG              PIC X OCCURS 16 TIMES.              013100     03  WS-OPT-VALS.                                                     013200         05  WS-OPT-VAL               PIC S9(9) COMP                      013300                                      OCCURS 16 TIMES.                    013400                                                                          013500 01  WS-RUN-PARM                      PIC S9(9) COMP VALUE ZERO.  20 SEP95013600 01  WS-INFO-LEN                      PIC S9(9) COMP VALUE 1.     20 SEP95013700 01  WS-INFO-TEXT                     PIC X.                      20 SEP95013800                                                                  20 SEP95013900 01  WS-CMD-ERR                       PIC S9(4) COMP.                     014000 01  WS-CMD-ERR-PARM                  PIC S9(4) COMP.                     014100                                                                          014200 01  WS-BUILD-CMD.                                                        014300     03  FILLER                       PIC X(06) VALUE "BUILD ".           014400     03  WS-BUILD-FILE                PIC X(07).                          014500     03  FILLER                       PIC X(23) VALUE                     014600         ";TEMP;REC=-80,3,F,ASCII".                                       014700     03  FILLER                       PIC X VALUE %15.                    014800                                                                          014900 01  WS-PURGE-CMD.                                                        015000     03  FILLER                       PIC X(06) VALUE "PURGE ".           015100     03  WS-PURGE-FILE                PIC X(07).                          015200     03  FILLER                       PIC X(05) VALUE                     015300         ",TEMP".                                                         015400     03  FILLER                       PIC X VALUE %15.                    015500                                                                          015600 01  WS-MPE-COMMAND.                                                      015700     03  WS-MPE-CMD                   PIC X(72).                          015800     03  FILLER                       PIC X VALUE %15.                    015900                                                                          016000 01  WS-RESULT-LEN                    PIC S9(9) COMP.                     016100 01  WS-RESULT-BUF                    PIC X(60000).                       016200$PAGE                                                                     016300 PROCEDURE DIVISION.                                                      016400 A000-MAIN-LOGIC.                                                         016500                                                                          016600                                                                          016700     PERFORM A010-INIT-ENVIRONMENT.                               20 SEP95016800                                                                          016900     IF HAVE-CONNECTION                                                   017000                                                                          017100        PERFORM UNTIL EOF-CONNECTION                                      017200                                                                          017300          PERFORM B000-READ-WRITE-DATA                                    017400                                                                          017500        END-PERFORM                                                       017600                                                                          017700        PERFORM C000-CLOSE-CONNECTION                                     017800                                                                          017900     END-IF.                                                              018000                                                                          018100     STOP RUN.                                                            018200                                                                          018300 A010-INIT-ENVIRONMENT.                                           20 SEP95018400                                                                  20 SEP95018500     MOVE WHEN-COMPILED               TO PROG-COMPILED.           20 SEP95018600     MOVE SPACES                      TO WS-OPT-FLAGS.            20 SEP95018700                                                                  20 SEP95018800     CALL "QSDK_INIT_PROCESS" USING   WS-INFO-LEN,                20 SEP95018900                                      WS-OPTIONAL-PARMS,          20 SEP95019000                                      WS-INFO-TEXT,               20 SEP95019100                                      WS-RUN-PARM,                20 SEP95019200                                      MY-PIN,                     20 SEP95019300                                      DAD-PIN.                    20 SEP95019400                                                                  20 SEP95019500     MOVE SPACES                      TO WS-OPT-FLAGS.                    019600     MOVE "Y"                         TO WS-OPT-FLAG (1).                 019700     MOVE ZERO                        TO WS-OPT-VAL (1).                  019800                                                                          019900     CALL "QSDK_OPEN" USING                                               020000          WS-NAME-BASE,                                                   020100          WS-OPTIONAL-PARMS,                                              020200          SD-SOCKET,                                                      020300          MY-PIN,                                                         020400          WS-ERR-STATUS.                                                  020500                                                                          020600     IF WS-ERR-CODE = ZERO                                                020700        MOVE MY-PIN                   TO WS-DISPLAY-32                    020800        DISPLAY " "                                                       020900        DISPLAY "Begin server (CSMPE) PIN: " WS-DISPLAY-32                021000        MOVE "Y"                      TO HAVE-CONNECTION-FLAG             021100     ELSE                                                                 021200        MOVE WS-ERR-CODE              TO WS-DISPLAY-32                    021300        DISPLAY " "                                                       021400        DISPLAY "Error opening connection: " WS-DISPLAY-32.               021500                                                                          021600                                                                          021700     IF HAVE-CONNECTION                                                   021800        MOVE MY-PIN                   TO WS-PIN                           021900        MOVE WS-RESULT-FILE           TO WS-BUILD-FILE,                   022000                                         WS-PURGE-FILE                    022100                                                                          022200        CALL INTRINSIC "HPCICOMMAND"  USING                               022300                                      WS-BUILD-CMD,                       022400                                      WS-CMD-ERR,                         022500                                      WS-CMD-ERR-PARM,                    022600                                      0                                   022700     END-IF.                                                              022800                                                                          022900 B000-READ-WRITE-DATA.                                                    023000                                                                          023100     MOVE ZERO                        TO WS-ERR-CODE.                     023200                                                                          023300     PERFORM UNTIL WS-ERR-CODE <> ZERO OR EOF-CONNECTION                  023400                                                                          023500       MOVE ZERO                      TO READ-ACTUAL                      023600       MOVE SPACES                    TO RW-BUFFER,                       023700                                         WS-OPT-FLAGS                     023800                                                                          023900       MOVE "Y"                       TO WS-OPT-FLAG (2)                  024000                                                                          024100       CALL "QSDK_READTRAN" USING                                         024200            SD-SOCKET,                                                    024300            WS-OPTIONAL-PARMS,                                            024400            WS-RT-PARMS,                                                  024500            READ-ACTUAL,                                                  024600            RW-BUFFER,                                                    024700            WS-ERR-STATUS                                                 024800                                                                          024900       IF WS-ERR-CODE = ZERO                                              025000          IF RW-BUFFER(1:READ-ACTUAL) = "QUIT"                            025100             MOVE "Y"                 TO EOF-CONNECTION-FLAG              025200          ELSE                                                            025300             IF RW-BUFFER(1:READ-ACTUAL) <> SPACES                        025400                PERFORM B100-SEND-RESULT                                  025500             END-IF                                                       025600          END-IF                                                          025700       ELSE                                                               025800          IF WS-ERR-CODE = 8                                              025900             MOVE ZERO                TO WS-ERR-CODE                      026000          ELSE                                                            026100             MOVE "Y"                 TO EOF-CONNECTION-FLAG              026200          END-IF                                                          026300       END-IF                                                             026400     END-PERFORM.                                                         026500                                                                          026600                                                                          026700 B100-SEND-RESULT.                                                        026800     PERFORM B200-GET-RESULT.                                             026900                                                                          027000     MOVE ":EOD"            TO WS-RESULT-BUF (WS-RESULT-LEN + 1:4)        027100     ADD 4                  TO WS-RESULT-LEN.                             027200     COMPUTE WS-WRITE-COUNT = ((WS-RESULT-LEN - 1) / 2048) + 1.           027300                                                                          027400     PERFORM VARYING I FROM 1 BY 1                                        027500               UNTIL I > WS-WRITE-COUNT                                   027600                                                                          027700       IF WS-RESULT-LEN > 2048                                            027800          MOVE 2048                   TO WRITE-LEN                        027900       ELSE                                                               028000          MOVE WS-RESULT-LEN          TO WRITE-LEN                        028100       END-IF                                                             028200       SUBTRACT WRITE-LEN             FROM WS-RESULT-LEN                  028300                                                                          028400       MOVE WS-RESULT-BUF ((I - 1) * 2048 + 1:WRITE-LEN)                  028500         TO RW-BUFFER (1:WRITE-LEN)                                       028600                                                                          028700       MOVE SPACES                    TO WS-OPT-FLAGS                     028800                                                                          028900       CALL "QSDK_WRITE" USING                                            029000            SD-SOCKET,                                                    029100            WRITE-LEN,                                                    029200            RW-BUFFER,                                                    029300            WS-OPTIONAL-PARMS,                                            029400            WS-ERR-STATUS                                                 029500       IF WS-ERR-CODE <> ZERO                                             029600          MOVE WS-ERR-CODE         TO WS-DISPLAY-32                       029700          DISPLAY "Write error: ", WS-DISPLAY-32                          029800       END-IF                                                             029900                                                                          030000     END-PERFORM.                                                         030100                                                                          030200 B200-GET-RESULT.                                                         030300     MOVE RW-BUFFER (1:READ-ACTUAL) TO WS-MPE-CMD.                        030400     MOVE " > "               TO WS-MPE-CMD (READ-ACTUAL + 1:).           030500     MOVE WS-RESULT-FILE      TO WS-MPE-CMD (READ-ACTUAL + 4:).           030600                                                                          030700     CALL INTRINSIC "HPCICOMMAND" USING                                   030800                                      WS-MPE-COMMAND,                     030900                                      WS-CMD-ERR,                         031000                                      WS-CMD-ERR-PARM,                    031100                                      0.                                  031200                                                                          031300     MOVE SPACES                      TO WS-RESULT-BUF.                   031400                                                                          031500     OPEN INPUT RESULT-FILE.                                              031600     MOVE "N"                         TO EOF-RESULT-FLAG.                 031700     MOVE ZERO                        TO WS-RESULT-LEN.                   031800                                                                          031900     PERFORM UNTIL EOF-RESULT                                             032000       READ RESULT-FILE AT END                                            032100                        MOVE "Y"      TO EOF-RESULT-FLAG                  032200       END-READ                                                           032300       IF NOT EOF-RESULT                                                  032400          IF RF-TEXT (1:1) <> %33                                         032500             MOVE "N"                 TO EOL-FLAG                         032600             MOVE ZERO                TO WS-LINE-LEN                      032700             PERFORM VARYING I FROM 80 BY -1                              032800                       UNTIL I < 1 OR EOL                                 032900               IF RF-TEXT (I:1) <> SPACE                                  033000                  MOVE "Y"            TO EOL-FLAG                         033100                  MOVE I              TO WS-LINE-LEN                      033200               END-IF                                                     033300             END-PERFORM                                                  033400             IF WS-LINE-LEN > ZERO                                        033500                MOVE RF-TEXT (1:WS-LINE-LEN) TO                           033600                 WS-RESULT-BUF (WS-RESULT-LEN + 1:WS-LINE-LEN)            033700                ADD WS-LINE-LEN       TO WS-RESULT-LEN                    033800                MOVE %15    TO WS-RESULT-BUF (WS-RESULT-LEN + 1:1)        033900                MOVE %12    TO WS-RESULT-BUF (WS-RESULT-LEN + 2:1)        034000                ADD 2       TO WS-RESULT-LEN                              034100             END-IF                                                       034200          END-IF                                                          034300       END-IF                                                             034400     END-PERFORM.                                                         034500                                                                          034600     CLOSE RESULT-FILE.                                                   034700                                                                          034800 C000-CLOSE-CONNECTION.                                                   034900                                                                          035000     CALL INTRINSIC "HPCICOMMAND" USING                                   035100                                      WS-PURGE-CMD,                       035200                                      WS-CMD-ERR,                         035300                                      WS-CMD-ERR-PARM,                    035400                                      0.                                  035500                                                                          035600     MOVE SPACES                      TO WS-OPT-FLAGS.                    035700                                                                          035800     CALL "QSDK_CLOSE" USING                                              035900          SD-SOCKET,                                                      036000          WS-OPTIONAL-PARMS,                                              036100          WS-ERR-STATUS.                                                  036200                                                                          036300     IF WS-ERR-CODE <> ZERO AND 10                                        036400        MOVE WS-ERR-CODE              TO WS-DISPLAY-32                    036500        DISPLAY " "                                                       036600        DISPLAY "Error closing connection: " WS-DISPLAY-32.               036700                                                                          036800     MOVE MY-PIN                      TO WS-DISPLAY-16.                   036900     DISPLAY " ".                                                         037000     DISPLAY "Terminating server (CSMPE) PIN: " WS-DISPLAY-16.            