RECSIZE=80;BLOCKFACTOR=51;CODE=1052;EXTENTS=6;FILESIZE=206;ASCII;FORMAT=F001000$TITLE "QSS Server Developer Kit- QECHO A.02.00 06/16/96"                 001100 IDENTIFICATION DIVISION.                                                 001200 PROGRAM-ID. QECHO.                                                       001300 DATE-WRITTEN. July 1995.                                                 001400 DATE-COMPILED.                                                           001500 AUTHOR. QSS.                                                             001600 INSTALLATION. QSS.                                                       001700*****************************************************************         001800*   NAME: QECHO.                                                *         001900*VERSION: A.02.00.                                              *         002000* SYSTEM: QSS Server Developer Kit.                             *         002100*   DATE: June 1995.                                            *         002200* AUTHOR: Duane Percox                                          *         002300*COMMENT: This is a simple echo server which will echo back the *         002400*         text that has been sent by the client.                *         002500*                                                               *         002600*         Note that this server maintains a connection so that  *         002700*         the client can continue to send text which this server*         002800*         will echo.  Typical echo servers connect/receive/echo/*         002900*         disconnect for each transaction.  You can use this    *         003000*         server to verify your ability to make and sustain a   *         003100*         connection.  It is also a nice way to check out the   *         003200*         relative speed of your connection (network).          *         003300*                                                               *         003400* Interesting sidenote: if you put a display in this code to    *         003500*                       show what text was received you might   *         003600*                       find that it shows up at the client     *         003700*                       (after being echoed) before it is fully *         003800*                       displayed!                              *         003900*                                                               *         004000*HISTORY:                                                       *         004100*                                                               *         004200*07/05/95 DAP(I) A.00.00 Initial coding                         *         004300*09/06/95 DAP(M) A.00.01 Final pass for release                 * 19 SEP95004400*06/06/96 DAP(M) A.02.00 QSDK A.02.xx release.                  * 19 SEP95004500*****************************************************************         004600 ENVIRONMENT DIVISION.                                                    004700 CONFIGURATION SECTION.                                                   004800 SOURCE-COMPUTER. HP-3000-MPE.                                            004900 OBJECT-COMPUTER. HP-3000-MPE.                                            005000*****************************************************************         005100*                                                               *         005200* COPYRIGHT (C) 1995-1996 QUINTESSENTIAL SCHOOL SYSTEMS.        *         005300*                                                               *         005400* THIS SOFTWARE IS FURNISHED UNDER A LICENSE FOR USE ONLY       *         005500* ON A SINGLE COMPUTER SYSTEM. THIS SOFTWARE, OR ANY COPIES     *         005600* THEREOF, IN ANY FORM, INCLUDING BUT NOT LIMITED TO HARDCOPY,  *         005700* MACHINE READABLE IN ANY FORM, MICROFILM OR MICROFICHE,        *         005800* MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY        *         005900* OTHER PERSON EXCEPT FOR USE ON SUCH SYSTEM AND TO ONE WHO     *         006000* AGREES TO THESE LICENSE TERMS. TITLE TO AND OWNERSHIP OF THIS *         006100* SOFTWARE SHALL AT ALL TIMES BELONG TO QSS.                    *         006200* THE INFORMATION IN THIS DOCUMENT IS SUBJECT TO CHANGE WITHOUT *         006300* NOTICE AND SHOULD NOT BE CONSTRUED AS A COMMITMENT BY         *         006400* QSS.                                                          *         006500*****************************************************************         006600$PAGE                                                                     006700 DATA DIVISION.                                                           006800 WORKING-STORAGE SECTION.                                                 006900 01  VERSION-DISPLAY.                                             19 SEP95007000     03  PROG-NAME                    PIC X(08) VALUE "QECHO".    19 SEP95007100     03  FILLER                       PIC X(02) VALUE SPACES.     19 SEP95007200     03  PROG-VERSION                 PIC X(07) VALUE "A.02.00".  19 SEP95007300     03  FILLER                       PIC X(10) VALUE             19 SEP95007400         " compiled ".                                            19 SEP95007500     03  PROG-COMPILED                PIC X(08) VALUE "99/99/99". 19 SEP95007600                                                                  19 SEP95007700 01  WS-DISPLAY-16                    PIC ZZZZ9-.                         007800 01  WS-DISPLAY-32                    PIC Z(8)9-.                         007900                                                                          008000 01  EOF-CONNECTION-FLAG              PIC X VALUE "N".                    008100     88  EOF-CONNECTION               VALUE "Y".                          008200                                                                          008300 01  WS-NAME-BASE                     PIC X(08) VALUE "TEMP".             008400 01  MY-PIN                           PIC S9(9) COMP VALUE ZERO.          008500 01  DAD-PIN                          PIC S9(9) COMP VALUE ZERO.  19 SEP95008600 01  SD-SOCKET                        PIC S9(9) COMP.                     008700                                                                          008800 01  WS-ERR-STATUS.                                                       008900     03  WS-ERR-CODE                  PIC S9(9) COMP.                     009000     03  WS-ERR-LOW-LEVEL             PIC S9(9) COMP.                     009100     03  WS-ERR-LL-ID                 PIC S9(9) COMP.                     009200                                                                          009300 01  READ-LEN                         PIC S9(9) COMP.                     009400 01  READ-ACTUAL                      PIC S9(9) COMP.                     009500 01  RW-BUFFER                        PIC X(2048).                        009600 01  WRITE-LEN                        PIC S9(9) COMP.                     009700                                                                          009800 01  WS-OPTIONAL-PARMS.                                                   009900     03  WS-OPT-FLAGS.                                                    010000         05  WS-OPT-FLAG              PIC X                               010100                                      OCCURS 16 TIMES.                    010200     03  WS-OPT-VALS.                                                     010300         05  WS-OPT-VAL               PIC S9(9) COMP                      010400                                      OCCURS 16 TIMES.                    010500                                                                  19 SEP95010600 01  WS-RUN-PARM                      PIC S9(9) COMP VALUE ZERO.  19 SEP95010700 01  WS-INFO-LEN                      PIC S9(9) COMP VALUE 1.     19 SEP95010800 01  WS-INFO-TEXT                     PIC X.                      19 SEP95010900$PAGE                                                                     011000 PROCEDURE DIVISION.                                                      011100 A000-MAIN-LOGIC.                                                         011200                                                                          011300     PERFORM A010-INIT-ENVIRONMENT.                               19 SEP95011400                                                                          011500     PERFORM UNTIL EOF-CONNECTION                                         011600                                                                          011700       PERFORM B000-READ-WRITE-DATA                                       011800                                                                          011900     END-PERFORM.                                                         012000                                                                          012100     PERFORM C000-CLOSE-CONNECTION.                                       012200                                                                          012300     STOP RUN.                                                            012400$PAGE                                                             19 SEP95012500 A010-INIT-ENVIRONMENT.                                           19 SEP95012600                                                                  19 SEP95012700     MOVE WHEN-COMPILED               TO PROG-COMPILED.           19 SEP95012800                                                                  19 SEP95012900     MOVE SPACES                      TO WS-OPT-FLAGS.            19 SEP95013000                                                                  19 SEP95013100     CALL "QSDK_INIT_PROCESS" USING   WS-INFO-LEN,                19 SEP95013200                                      WS-OPTIONAL-PARMS,          19 SEP95013300                                      WS-INFO-TEXT,               19 SEP95013400                                      WS-RUN-PARM,                19 SEP95013500                                      MY-PIN,                     19 SEP95013600                                      DAD-PIN.                    19 SEP95013700                                                                  19 SEP95013800     MOVE SPACES                      TO WS-OPT-FLAGS.                    013900                                                                          014000     CALL "QSDK_OPEN" USING                                               014100          WS-NAME-BASE,                                                   014200          WS-OPTIONAL-PARMS,                                              014300          SD-SOCKET,                                                      014400          MY-PIN,                                                         014500          WS-ERR-STATUS.                                                  014600                                                                          014700     IF WS-ERR-CODE = ZERO                                                014800        MOVE MY-PIN                   TO WS-DISPLAY-16                    014900        MOVE SD-SOCKET                TO WS-DISPLAY-32                    015000        DISPLAY " "                                                       015100        DISPLAY "Begin server (QECHO) PIN: " WS-DISPLAY-16                015200     ELSE                                                                 015300        MOVE "Y"                      TO EOF-CONNECTION-FLAG              015400        MOVE WS-ERR-CODE              TO WS-DISPLAY-32                    015500        DISPLAY " "                                                       015600        DISPLAY "Error opening connection: " WS-DISPLAY-32.               015700$PAGE                                                             19 SEP95015800 B000-READ-WRITE-DATA.                                                    015900                                                                          016000     MOVE ZERO                        TO WS-ERR-CODE.                     016100                                                                          016200     PERFORM UNTIL WS-ERR-CODE <> ZERO                                    016300                                                                          016400       MOVE 2048                      TO READ-LEN                         016500       MOVE ZERO                      TO READ-ACTUAL                      016600       MOVE SPACES                    TO RW-BUFFER,                       016700                                         WS-OPT-FLAGS                     016800                                                                          016900       MOVE "Y"                       TO WS-OPT-FLAG  (1)                 017000       MOVE ZERO                      TO WS-OPT-VAL (1)                   017100                                                                          017200       CALL "QSDK_READ" USING                                             017300            SD-SOCKET,                                                    017400            READ-LEN,                                                     017500            WS-OPTIONAL-PARMS,                                            017600            READ-ACTUAL,                                                  017700            RW-BUFFER,                                                    017800            WS-ERR-STATUS                                                 017900                                                                          018000       IF WS-ERR-CODE = ZERO                                              018100          MOVE READ-ACTUAL            TO WRITE-LEN                        018200          MOVE SPACES                 TO WS-OPT-FLAGS                     018300          CALL "QSDK_WRITE" USING                                         018400               SD-SOCKET,                                                 018500               WRITE-LEN,                                                 018600               RW-BUFFER,                                                 018700               WS-OPTIONAL-PARMS,                                         018800               WS-ERR-STATUS                                              018900          IF WS-ERR-CODE <> ZERO                                          019000             MOVE WS-ERR-CODE         TO WS-DISPLAY-32                    019100             DISPLAY "Write error: ", WS-DISPLAY-32                       019200          ELSE                                                            019300             IF RW-BUFFER(1:READ-ACTUAL) = "QUIT" then                    019400                MOVE "Y"              TO EOF-CONNECTION-FLAG              019500             END-IF                                                       019600          END-IF                                                          019700       END-IF                                                             019800     END-PERFORM.                                                         019900$PAGE                                                             19 SEP95020000 C000-CLOSE-CONNECTION.                                                   020100                                                                          020200     IF SD-SOCKET <> ZERO                                                 020300        MOVE SPACES                      TO WS-OPT-FLAGS                  020400        CALL "QSDK_CLOSE" USING                                           020500             SD-SOCKET,                                                   020600             WS-OPTIONAL-PARMS,                                           020700             WS-ERR-STATUS                                                020800        IF WS-ERR-CODE <> ZERO AND 10                                     020900           MOVE WS-ERR-CODE              TO WS-DISPLAY-32                 021000           DISPLAY " "                                                    021100           DISPLAY "Error closing connection: " WS-DISPLAY-32.            021200                                                                          021300     MOVE MY-PIN                      TO WS-DISPLAY-16.                   021400     DISPLAY " ".                                                         021500     DISPLAY "Terminating server (QECHO) PIN: " WS-DISPLAY-16.            