RECSIZE=80;BLOCKFACTOR=51;CODE=1052;EXTENTS=9;FILESIZE=366;ASCII;FORMAT=F001000$TITLE "QSS Server Developer Kit - QLISTEN A.02.00 06/15/96"      21 JUN96001100 IDENTIFICATION DIVISION.                                                 001200 PROGRAM-ID. QLISTEN.                                                     001300 DATE-WRITTEN. June 1995.                                                 001400 DATE-COMPILED.                                                           001500 AUTHOR. QSS.                                                             001600 INSTALLATION. QSS.                                                       001700*****************************************************************         001800*   NAME: QLISTEN.                                              *         001900*VERSION: A.02.00.                                              *         002000* SYSTEM: QSS Server Developer Kit (QSDK)                       *         002100*   DATE: June 1995.                                            *         002200* AUTHOR: Duane Percox                                          *         002300*COMMENT: This is a generic listener which can be used by any   *         002400*         server to act as the daemon for handling incoming     *         002500*         client connections.                                   *         002600*                                                               *         002700*         This is an example of creating a listener/server pair.*         002800*         The code is written so that if the ;parm of the run   *         002900*         statement is zero it will prompt for the parms.  If   *         003000*         the ;parm <>0 then the parms are passed by the info   *         003100*         string. The basic rule is if you want to use this with*         003200*         QSUPERL the parms should come from the ;info= and if  *         003300*         you are running this in a qlisten/server matched pair *         003400*         you should put the prompts in the batch job.          *         003500*                                                               *         003600*         In either case, the clients for the tcp port that you *         003700*         are listening on will be serviced by unique instances *         003800*         of your server program, each being a process that is  *         003900*         a descendant of this process.                         *         004000*                                                               *         004100*         This source code can be used as-is/modified for your  *         004200*         non-commercial use by license holders of "QSDK", the  *         004300*         Quintessential Server Developer Kit.                  *         004400*                                                               *         004500*         Please feel free to use this code in helping you to   *         004600*         determine how QSDK listeners work.                    *         004700*                                                               *         004800*HISTORY:                                                       *         004900*                                                               *         005000*07/05/95 DAP(I) A.00.00 Initial coding                         *         005100*09/06/95 DAP(M) A.00.01 Final cleanup for release.             * 19 SEP95005200*06/15/95 DAP(M) A.02.00 QSDK A.02.xx release.                  * 19 SEP95005300*****************************************************************         005400$PAGE                                                                     005500 ENVIRONMENT DIVISION.                                                    005600 CONFIGURATION SECTION.                                                   005700 SOURCE-COMPUTER. HP-3000-MPE.                                            005800 OBJECT-COMPUTER. HP-3000-MPE.                                            005900*****************************************************************         006000*                                                               *         006100* COPYRIGHT (C) 1995-1996 QUINTESSENTIAL SCHOOL SYSTEMS.        *         006200*                                                               *         006300* THIS SOFTWARE IS FURNISHED UNDER A LICENSE FOR USE ONLY       *         006400* ON A SINGLE COMPUTER SYSTEM. THIS SOFTWARE, OR ANY COPIES     *         006500* THEREOF, IN ANY FORM, INCLUDING BUT NOT LIMITED TO HARDCOPY,  *         006600* MACHINE READABLE IN ANY FORM, MICROFILM OR MICROFICHE,        *         006700* MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY        *         006800* OTHER PERSON EXCEPT FOR USE ON SUCH SYSTEM AND TO ONE WHO     *         006900* AGREES TO THESE LICENSE TERMS. TITLE TO AND OWNERSHIP OF THIS *         007000* SOFTWARE SHALL AT ALL TIMES BELONG TO QSS.                    *         007100* THE INFORMATION IN THIS DOCUMENT IS SUBJECT TO CHANGE WITHOUT *         007200* NOTICE AND SHOULD NOT BE CONSTRUED AS A COMMITMENT BY         *         007300* QSS.                                                          *         007400*                                                               *         007500*****************************************************************         007600$PAGE                                                                     007700 DATA DIVISION.                                                           007800 WORKING-STORAGE SECTION.                                                 007900 01  VERSION-DISPLAY.                                                     008000     03  PROG-NAME                    PIC X(08) VALUE "QLISTEN".          008100     03  FILLER                       PIC X(02) VALUE SPACES.             008200     03  PROG-VERSION                 PIC X(07) VALUE "A.02.00".  19 SEP95008300     03  FILLER                       PIC X(10) VALUE                     008400         " compiled ".                                                    008500     03  PROG-COMPILED                PIC X(08) VALUE "99/99/99".         008600                                                                          008700 01  I                                PIC S9(9) COMP.                     008800                                                                          008900 01  END-THE-LISTENER-FLAG            PIC X VALUE "N".                    009000     88  END-THE-LISTENER             VALUE "Y".                          009100 01  DONE-LISTENING-FLAG              PIC X VALUE "N".                    009200     88  DONE-LISTENING               VALUE "Y".                          009300 01  HAVE-CONNECTION-FLAG             PIC X VALUE "N".            19 SEP95009400     88  HAVE-CONNECTION              VALUE "Y".                  19 SEP95009500 01  FOUND-DOT-FLAG                   PIC X VALUE "N".                    009600     88  FOUND-DOT                    VALUE "Y".                          009700                                                                          009800 01  WS-DISPLAY-16                    PIC ZZZZ9-.                         009900 01  WS-DISPLAY-32                    PIC Z(8)9-.                         010000                                                                          010100 01  WS-MAX-CON                       PIC 999.                            010200 01  WS-PORT-NO                       PIC 9(5).                           010300                                                                          010400 01  WS-GRACEFUL                      PIC S9(9) COMP VALUE 1.             010500 01  WS-SOCKET-NAME                   PIC X(16) VALUE SPACES.             010600 01  WS-TCP-PORT                      PIC S9(9) COMP.                     010700                                                                  19 SEP95010800 01  LISTEN-DATA.                                                         010900     03  SD-SOCKET                    PIC S9(9) COMP.                     011000     03  CLIENT-TCP-PORT              PIC S9(9) COMP.                     011100     03  PROC-MSG-LEN                 REDEFINES CLIENT-TCP-PORT           011200                                      PIC S9(9) COMP.                     011300     03  LD-MESSAGE.                                                      011400         05  CLIENT-IP-ADDR-BYTE.                                         011500             07  CIA-B-1              PIC X.                              011600             07  CIA-B-2              PIC X.                              011700             07  CIA-B-3              PIC X.                              011800             07  CIA-B-4              PIC X.                              011900         05  CLIENT-IP-ADDR-DOT       PIC X(16).                          012000         05  FILLER                   PIC X(236).                         012100                                                                          012200                                                                          012300 01  WS-ERR-STATUS.                                                       012400     03  WS-ERR-CODE                  PIC S9(9) COMP.                     012500     03  WS-ERR-LOW-LEVEL             PIC S9(9) COMP.                     012600     03  WS-ERR-LL-ID                 PIC S9(9) COMP.                     012700                                                                          012800 01  WS-OPTIONAL-PARMS.                                                   012900     03  WS-OPT-FLAGS.                                                    013000         05  WS-OPT-FLAG              PIC X                               013100                                      OCCURS 16 TIMES.                    013200     03  WS-OPT-VALS.                                                     013300         05  WS-OPT-VAL               PIC S9(9) COMP                      013400                                      OCCURS 16 TIMES.                    013500                                                                          013600 01  WS-NAME-BASE                     PIC X(08) VALUE "TEMP".             013700 01  WS-SERVER-NAME                   PIC X(30) VALUE SPACES.             013800 01  RUN-PARM                         PIC S9(9) COMP VALUE ZERO.          013900 01  INFO-LEN                         PIC S9(9) COMP VALUE ZERO.          014000 01  INFO-STRING                      PIC X.                              014100 01  SERVER-PIN                       PIC S9(9) COMP.                     014200                                                                          014300 01  WS-RUN-PARM                      PIC S9(9) COMP VALUE ZERO.          014400 01  WS-INFO-LEN                      PIC S9(9) COMP VALUE 60.    19 SEP95014500 01  WS-INFO-TEXT                     VALUE SPACES.                       014600     03  WS-INFO-SERVER               PIC X(36).                          014700     03  WS-INFO-SOCKET-NAME          PIC X(16).                          014800     03  WS-INFO-PORT                 PIC 9(5).                           014900     03  WS-INFO-MAX-CON              PIC 9(3).                           015000                                                                  19 SEP95015100 01  WS-DUMMY-0                       PIC S9(9) COMP VALUE ZERO.  19 SEP95015200 01  SD-LISTEN                        PIC S9(9) COMP.             19 SEP95015300 01  FD-MESSAGE                       PIC S9(9) COMP.             19 SEP95015400 01  FD-MESSAGE-DAD                   PIC S9(9) COMP.             19 SEP95015500 01  WS-MY-PIN                        PIC S9(9) COMP VALUE ZERO.          015600 01  WS-DAD-PIN                       PIC S9(9) COMP VALUE ZERO.          015700$PAGE                                                                     015800 PROCEDURE DIVISION.                                                      015900 A000-MAIN-LOGIC.                                                         016000                                                                          016100     PERFORM A010-GET-LISTENER-PARMS.                                     016200                                                                          016300     PERFORM A020-CREATE-LISTEN-SOCKET.                                   016400                                                                          016500     IF NOT END-THE-LISTENER                                      19 SEP95016600        PERFORM B000-CREATE-SERVER.                               19 SEP95016700                                                                  19 SEP95016800     PERFORM UNTIL END-THE-LISTENER                                       016900                                                                          017000       IF NOT END-THE-LISTENER                                            017100          PERFORM B100-LISTEN-FOR-CONNECTION                              017200          IF NOT END-THE-LISTENER                                         017300             IF HAVE-CONNECTION                                   19 SEP95017400                PERFORM B200-START-SERVER                         19 SEP95017500                PERFORM B000-CREATE-SERVER                        19 SEP95017600             END-IF                                               19 SEP95017700          END-IF                                                          017800       END-IF                                                             017900                                                                          018000     END-PERFORM.                                                         018100                                                                          018200     IF NOT END-THE-LISTENER                                              018300        PERFORM D000-CLOSE-SOCKET.                                19 SEP95018400                                                                          018500     STOP RUN.                                                            018600$PAGE                                                             19 SEP95018700 A010-GET-LISTENER-PARMS.                                                 018800                                                                          018900     MOVE WHEN-COMPILED               TO PROG-COMPILED.                   019000     DISPLAY VERSION-DISPLAY.                                             019100     DISPLAY " ".                                                         019200                                                                          019300     MOVE SPACES                      TO WS-OPT-FLAGS.                    019400                                                                  19 SEP95019500     CALL "QSDK_INIT_PROCESS" USING   WS-INFO-LEN,                        019600                                      WS-OPTIONAL-PARMS,                  019700                                      WS-INFO-TEXT,                       019800                                      WS-RUN-PARM,                        019900                                      WS-MY-PIN,                          020000                                      WS-DAD-PIN.                         020100                                                                          020200     IF WS-RUN-PARM <> ZERO                                               020300        MOVE WS-INFO-SERVER           TO WS-SERVER-NAME                   020400        MOVE WS-INFO-SOCKET-NAME      TO WS-SOCKET-NAME                   020500        MOVE WS-INFO-PORT             TO WS-PORT-NO                       020600        MOVE WS-INFO-MAX-CON          TO WS-MAX-CON                       020700     ELSE                                                                 020800        MOVE ZERO                     TO WS-MAX-CON                       020900                                         WS-PORT-NO                       021000        MOVE SPACES                   TO WS-SERVER-NAME,                  021100                                         WS-SOCKET-NAME                   021200        DISPLAY "Server? " WITH NO ADVANCING                              021300        ACCEPT  WS-SERVER-NAME                                            021400                                                                          021500        MOVE "N"                      TO FOUND-DOT-FLAG                   021600        PERFORM VARYING I FROM 1 BY 1                                     021700                  UNTIL I > 8 OR FOUND-DOT                                021800          IF WS-SERVER-NAME(I:1) <> "."                                   021900             MOVE WS-SERVER-NAME(I:1) TO WS-SOCKET-NAME(I:1)              022000          ELSE                                                            022100             MOVE "Y"                 TO FOUND-DOT-FLAG                   022200          END-IF                                                          022300        END-PERFORM                                                       022400                                                                          022500        DISPLAY "Max queued connections (0-999)? "                        022600          WITH NO ADVANCING                                               022700        ACCEPT  WS-MAX-CON FREE                                           022800          ON INPUT ERROR                                                  022900          DISPLAY "Invalid number of connections... aborting!"            023000          STOP RUN                                                        023100        END-ACCEPT                                                        023200                                                                          023300        DISPLAY "TCP Port (1-32767)? " WITH NO ADVANCING                  023400        ACCEPT  WS-PORT-NO FREE                                           023500          ON INPUT ERROR                                                  023600          DISPLAY "Invalid TCP port number... aborting!"                  023700          STOP RUN                                                        023800        END-ACCEPT                                                        023900     END-IF.                                                              024000                                                                          024100     MOVE WS-MY-PIN                   TO WS-DISPLAY-16.           19 SEP95024200     DISPLAY " ".                                                         024300     DISPLAY "** QLISTEN Parms for Pin: ", WS-DISPLAY-16, " **".  19 SEP95024400     DISPLAY " ".                                                         024500     DISPLAY "   TCP port number: " WS-PORT-NO.                   19 SEP95024600     DISPLAY "   Queued connects: " WS-MAX-CON.                   19 SEP95024700     DISPLAY "       Socket name: " WS-SOCKET-NAME.               19 SEP95024800     DISPLAY "    Server program: " WS-SERVER-NAME.               19 SEP95024900     DISPLAY " ".                                                         025000$PAGE                                                             19 SEP95025100 A020-CREATE-LISTEN-SOCKET.                                               025200                                                                          025300     MOVE ZERO                        TO SD-LISTEN.                       025400     MOVE SPACES                      TO WS-OPTIONAL-PARMS.               025500                                                                  19 SEP95025600* Overide the maximum queued connections default                  19 SEP95025700     IF WS-MAX-CON > ZERO                                         19 SEP95025800        MOVE "Y"                      TO WS-OPT-FLAG (1)          19 SEP95025900        MOVE WS-MAX-CON               TO WS-OPT-VAL (1)           19 SEP95026000     END-IF.                                                      19 SEP95026100                                                                  19 SEP95026200* Set the timeout value to 0 which disables the timeout for       19 SEP95026300* the listen socket. This means we will not get any return from   19 SEP95026400* a listen unless its a network error, or a connection.           19 SEP95026500     MOVE "Y"                         TO WS-OPT-FLAG (2).         19 SEP95026600     MOVE ZERO                        TO WS-OPT-VAL (2).          19 SEP95026700                                                                  19 SEP95026800     MOVE WS-PORT-NO                  TO WS-TCP-PORT.                     026900                                                                          027000     CALL "QSDK_CREATE_SOCKET" USING                                      027100          WS-SOCKET-NAME,                                                 027200          WS-TCP-PORT,                                                    027300          WS-OPTIONAL-PARMS,                                              027400          SD-LISTEN,                                                      027500          WS-ERR-STATUS.                                                  027600                                                                          027700     IF WS-ERR-CODE = ZERO THEN                                           027800        DISPLAY " "                                                       027900        DISPLAY "Socket created..."                                       028000     ELSE                                                                 028100        MOVE "Y"                      TO END-THE-LISTENER-FLAG            028200        DISPLAY " WS-ERR-CODE: " WS-ERR-CODE                              028300        DISPLAY "   WS-ERR-LL: " WS-ERR-LOW-LEVEL                         028400        DISPLAY "WS-ERR-LL-ID: " WS-ERR-LL-ID.                            028500$PAGE                                                             19 SEP95028600 B000-CREATE-SERVER.                                                      028700                                                                          028800     MOVE SPACES                      TO WS-OPT-FLAGS.                    028900     MOVE ZERO                        TO WS-ERR-CODE,                     029000                                         SERVER-PIN.                      029100                                                                          029200     MOVE ZERO                        TO RUN-PARM.                19 SEP95029300                                                                  19 SEP95029400     CALL "QSDK_CREATE_SERVER" USING                                      029500          WS-SERVER-NAME,                                                 029600          RUN-PARM,                                                       029700          INFO-LEN,                                                       029800          INFO-STRING,                                                    029900          WS-OPTIONAL-PARMS,                                              030000          SERVER-PIN,                                                     030100          WS-ERR-STATUS.                                                  030200                                                                          030300     IF WS-ERR-CODE <= ZERO                                               030400        MOVE SERVER-PIN               TO WS-DISPLAY-16                    030500        DISPLAY " "                                                       030600        DISPLAY "Server process created: ", WS-DISPLAY-16                 030700     ELSE                                                                 030800        MOVE "Y"                      TO END-THE-LISTENER-FLAG            030900        MOVE WS-ERR-CODE              TO WS-DISPLAY-32                    031000        DISPLAY " "                                                       031100        DISPLAY "Error creating server: ", WS-DISPLAY-32.                 031200$PAGE                                                             19 SEP95031300 B100-LISTEN-FOR-CONNECTION.                                              031400                                                                          031500     MOVE SPACES                      TO WS-OPT-FLAGS.                    031600                                                                  19 SEP95031700* set the buffer size to 2048, which is our favorite size         19 SEP95031800     MOVE "Y"                         TO WS-OPT-FLAG (1).         19 SEP95031900     MOVE 2048                        TO WS-OPT-VAL (1).          29 DEC95032000                                                                  19 SEP95032100     MOVE "N"                         TO HAVE-CONNECTION-FLAG.    19 SEP95032200     MOVE ZERO                        TO SD-SOCKET.               19 SEP95032300                                                                  19 SEP95032400     CALL "QSDK_LISTEN" USING                                             032500          SD-LISTEN,                                                      032600          WS-OPTIONAL-PARMS,                                              032700          LISTEN-DATA,                                                    032800          WS-ERR-STATUS.                                                  032900                                                                          033000     IF WS-ERR-CODE = ZERO                                                033100        DISPLAY " "                                               19 SEP95033200        DISPLAY "** Connection established **"                    19 SEP95033300        MOVE CLIENT-TCP-PORT          TO WS-DISPLAY-16            19 SEP95033400        DISPLAY " "                                               19 SEP95033500        DISPLAY "Client port: ", WS-DISPLAY-16                    19 SEP95033600        DISPLAY "Client addr: ", CLIENT-IP-ADDR-DOT               19 SEP95033700        MOVE "Y"                      TO HAVE-CONNECTION-FLAG     19 SEP95033800     ELSE                                                                 033900        MOVE WS-ERR-CODE              TO WS-DISPLAY-32                    034000        DISPLAY " "                                                       034100        DISPLAY "Error on listen: ", WS-DISPLAY-32                        034200        MOVE "Y"                      TO END-THE-LISTENER-FLAG            034300     END-IF.                                                              034400$PAGE                                                             19 SEP95034500 B200-START-SERVER.                                                       034600                                                                          034700     MOVE ZERO                        TO WS-ERR-CODE.                     034800                                                                          034900     CALL "QSDK_START_SERVER" USING                                       035000          SD-SOCKET,                                                      035100          SERVER-PIN,                                                     035200          WS-NAME-BASE,                                                   035300          WS-ERR-STATUS.                                                  035400                                                                          035500     IF WS-ERR-CODE = ZERO                                                035600        MOVE SERVER-PIN               TO WS-DISPLAY-16                    035700        DISPLAY " "                                                       035800        DISPLAY "Server process started: ", WS-DISPLAY-16                 035900     ELSE                                                                 036000        MOVE WS-ERR-CODE              TO WS-DISPLAY-32                    036100        DISPLAY " "                                                       036200        DISPLAY "Error starting server: ", WS-DISPLAY-32.                 036300$PAGE                                                             19 SEP95036400 D000-CLOSE-SOCKET.                                               19 SEP95036500                                                                  19 SEP95036600     CALL "QSDK_CLOSE_SOCKET" USING                                       036700          SD-LISTEN,                                                      036800          WS-GRACEFUL,                                                    036900          WS-ERR-CODE.                                                    037000                                                                          037100     IF WS-ERR-CODE <> ZERO                                               037200        MOVE WS-ERR-CODE              TO WS-DISPLAY-32                    037300        DISPLAY " "                                                       037400        DISPLAY "Error attempting to close socket: ",                     037500                WS-DISPLAY-32.                                            