RECSIZE=80;BLOCKFACTOR=51;CODE=1052;EXTENTS=7;FILESIZE=285;ASCII;FORMAT=F001000$TITLE "QSS Server Developer Kit - QTRANC A.02.00 06/25/96"       25 JUN96001100 IDENTIFICATION DIVISION.                                                 001200 PROGRAM-ID. QTRANC.                                              25 JUN96001300 DATE-WRITTEN. June 1996.                                         21 JUN96001400 DATE-COMPILED.                                                           001500 AUTHOR. QSS.                                                      9 FEB94001600 INSTALLATION. QSS.                                                9 FEB94001700*****************************************************************         001800*   NAME: QTRANC.                                               *         001900*VERSION: A.02.00.                                              *         002000* SYSTEM: QSS Server Developer Kit (QSDK)                       *         002100*   DATE: June 1996.                                            *         002200* AUTHOR: Duane Percox                                          *         002300*COMMENT: This is a sample program which demonstrates the two   *         002400*         following features:                                   *         002500*                                                               *         002600*         1) Connecting to a 3k server (blanks for local system)*         002700*         2) Requesting and decoding the results from a file xfr*         002800*            processed by the server using QSDK_FILE_XFR.       *         002900*                                                               *         003000*         This code displays the results as record lengths which*         003100*         provides a good measure if things are working ok.     *         003200*                                                               *         003300*         This source code can be used as-is/modified for your  *         003400*         non-commercial use by license holders of "QSDK", the  *         003500*         QSS Server Developer's Kit.                           *         003600*                                                               *         003700*HISTORY:                                                       *         003800*                                                               *         003900*06/25/96 DAP(I) A.02.00 Initial coding                         *         004000*****************************************************************         004100 ENVIRONMENT DIVISION.                                                    004200 CONFIGURATION SECTION.                                                   004300 SOURCE-COMPUTER. HP-3000-MPE.                                            004400 OBJECT-COMPUTER. HP-3000-MPE.                                            004500*****************************************************************         004600*                                                               *         004700* COPYRIGHT (C) 1996 QUINTESSENTIAL SCHOOL SYSTEMS.             * 21 JUN96004800*                                                               *         004900* THIS SOFTWARE IS FURNISHED UNDER A LICENSE FOR USE ONLY       *         005000* ON A SINGLE COMPUTER SYSTEM. THIS SOFTWARE, OR ANY COPIES     *         005100* THEREOF, IN ANY FORM, INCLUDING BUT NOT LIMITED TO HARDCOPY,  *         005200* MACHINE READABLE IN ANY FORM, MICROFILM OR MICROFICHE,        *         005300* MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY        *         005400* OTHER PERSON EXCEPT FOR USE ON SUCH SYSTEM AND TO ONE WHO     *         005500* AGREES TO THESE LICENSE TERMS. TITLE TO AND OWNERSHIP OF THIS *         005600* SOFTWARE SHALL AT ALL TIMES BELONG TO QSS.                    *  9 FEB94005700* THE INFORMATION IN THIS DOCUMENT IS SUBJECT TO CHANGE WITHOUT *         005800* NOTICE AND SHOULD NOT BE CONSTRUED AS A COMMITMENT BY         *         005900* QSS.                                                          *  9 FEB94006000*                                                               *         006100*****************************************************************         006200$PAGE                                                                     006300 DATA DIVISION.                                                           006400 WORKING-STORAGE SECTION.                                                 006500 01  VERSION-DISPLAY.                                                     006600     03  PROG-NAME                    PIC X(08) VALUE "QTRANC".           006700     03  FILLER                       PIC X(02) VALUE SPACES.             006800     03  PROG-VERSION                 PIC X(07) VALUE "A.02.00".          006900     03  FILLER                       PIC X(10) VALUE                     007000         " compiled ".                                                    007100                                                                          007200 01  I                                PIC S9(9) COMP.             27 JUN96007300 01  J                                PIC S9(9) COMP.             27 JUN96007400                                                                   9 FEB94007500 01  WS-REMOTE-NODE                   PIC X(50) VALUE SPACES.     25 JUN96007600 01  WS-FILE-NAME                     PIC X(50) VALUE SPACES.     25 JUN96007700 01  WS-METHOD                        PIC X(3) VALUE SPACES.      25 JUN96007800 01  WS-REMOTE-TCP-PORT               PIC 9(5).                   25 JUN96007900                                                                          008000 01  REMOTE-NODE                      PIC X(50).                  21 JUN96008100 01  REMOTE-TCP-PORT                  PIC S9(9) COMP.             21 JUN96008200 01  SD-SOCKET                        PIC S9(9) COMP.             21 JUN96008300                                                                  25 JUN96008400 01  RW-BUFFER                        PIC X(2048).                27 JUN96008500 01  REC-BUF                          PIC X(2048).                27 JUN96008600                                                                  27 JUN96008700 01  REC-LEN                          PIC S9(9) COMP.             27 JUN96008800 01  READ-LEN                         PIC S9(9) COMP.             25 JUN96008900 01  READ-ACTUAL                      PIC S9(9) COMP.             25 JUN96009000 01  WRITE-LEN                        PIC S9(9) COMP.             25 JUN96009100                                                                  25 JUN96009200 01  WS-OPTIONAL-PARMS.                                           21 JUN96009300     03  WS-OPTIONAL-FLAG             PIC X OCCURS 16 TIMES.      21 JUN96009400     03  WS-OPTIONAL-VAL              PIC S9(9) COMP              21 JUN96009500                                      OCCURS 16 TIMES.            21 JUN96009600                                                                  21 JUN96009700 01  WS-ERR-STATUS.                                               21 JUN96009800     03  WS-ERR-CODE                  PIC S9(9) COMP.             21 JUN96009900     03  WS-ERR-LL                    PIC S9(9) COMP.             21 JUN96010000     03  WS-ERR-LL-ID                 PIC S9(9) COMP.             21 JUN96010100                                                                  25 JUN96010200 01  EOF-READ-FLAG                    PIC X.                      25 JUN96010300     88  EOF-READ                     VALUE "Y".                  25 JUN96010400 01  ALL-FINISHED-FLAG                PIC X.                      25 JUN96010500     88  ALL-FINISHED                 VALUE "Y".                  25 JUN96010600                                                                  25 JUN96010700 01  WS-REC-LEN-X.                                                25 JUN96010800     03  WS-REC-LEN                   PIC S9(4) COMP.             25 JUN96010900$PAGE                                                              9 FEB94011000 PROCEDURE DIVISION.                                                      011100 MAIN-LOGIC SECTION.                                                      011200 ML-0.                                                                    011300     MOVE SPACES TO WS-REMOTE-NODE.                               21 JUN96011400     MOVE ZERO TO WS-REMOTE-TCP-PORT.                             21 JUN96011500     DISPLAY "Remote node? " WITH NO ADVANCING.                   21 JUN96011600     ACCEPT  WS-REMOTE-NODE.                                      21 JUN96011700                                                                  21 JUN96011800     DISPLAY "TCP Port? " WITH NO ADVANCING.                      21 JUN96011900     ACCEPT  WS-REMOTE-TCP-PORT FREE.                             21 JUN96012000                                                                  21 JUN96012100     MOVE WS-REMOTE-NODE              TO REMOTE-NODE.             21 JUN96012200     MOVE WS-REMOTE-TCP-PORT          TO REMOTE-TCP-PORT.         21 JUN96012300                                                                  21 JUN96012400     IF REMOTE-TCP-PORT = ZERO                                    21 JUN96012500        STOP RUN.                                                 21 JUN96012600                                                                  21 JUN96012700     MOVE ZERO                        TO SD-SOCKET.               21 JUN96012800     MOVE SPACES                      TO WS-OPTIONAL-PARMS.       21 JUN96012900                                                                  22 JUN96013000* allow a timeout of 10 seconds for the socket...                 26 JUN96013100     MOVE "Y"                         TO WS-OPTIONAL-FLAG (1).    25 JUN96013200     MOVE 1000                        TO WS-OPTIONAL-VAL (1).     26 JUN96013300                                                                  22 JUN96013400     CALL "QSDK_CONNECT" USING        REMOTE-NODE,                21 JUN96013500                                      REMOTE-TCP-PORT,            21 JUN96013600                                      WS-OPTIONAL-PARMS,          21 JUN96013700                                      SD-SOCKET,                  21 JUN96013800                                      WS-ERR-STATUS.              21 JUN96013900                                                                  21 JUN96014000     DISPLAY "  Socket id: ", SD-SOCKET.                          21 JUN96014100     DISPLAY "   Err code: ", WS-ERR-CODE.                        21 JUN96014200     DISPLAY "Err code-ll: ", WS-ERR-LL.                          21 JUN96014300     DISPLAY "  Err-ll-id: ", WS-ERR-LL-ID.                       21 JUN96014400                                                                  25 JUN96014500     PERFORM B000-GET-FILE.                                       25 JUN96014600                                                                  21 JUN96014700     IF SD-SOCKET <> ZERO                                         21 JUN96014800        CALL "QSDK_CLOSE" USING       SD-SOCKET,                  21 JUN96014900                                      WS-OPTIONAL-PARMS,          21 JUN96015000                                      WS-ERR-STATUS.              21 JUN96015100     GO TO ML-0.                                                  21 JUN96015200                                                                  21 JUN96015300 B000-GET-FILE.                                                   25 JUN96015400* A method is a 'G' followed by these options:                    25 JUN96015500*                                                                 25 JUN96015600*   RA == Record mode, use acknowledgement protocol               26 JUN96015700*   BA == Block mode, use acknowledgement  protocol               26 JUN96015800*   RN == Record mode, no acknowledgement                         25 JUN96015900*   BN == Block mode, no acknowledgement                          25 JUN96016000                                                                  25 JUN96016100     DISPLAY " ".                                                 25 JUN96016200     DISPLAY "Method? " WITH NO ADVANCING.                        25 JUN96016300     ACCEPT  WS-METHOD.                                           25 JUN96016400     DISPLAY "File to transfer? " WITH NO ADVANCING.              25 JUN96016500     ACCEPT  WS-FILE-NAME.                                        25 JUN96016600                                                                  25 JUN96016700     MOVE WS-METHOD (1:3)             TO RW-BUFFER (1:3).         25 JUN96016800     MOVE WS-FILE-NAME                TO RW-BUFFER (5:50).        25 JUN96016900                                                                  25 JUN96017000     MOVE SPACES                      TO WS-OPTIONAL-PARMS.       25 JUN96017100     MOVE 55                          TO WRITE-LEN.               25 JUN96017200                                                                  25 JUN96017300     CALL "QSDK_WRITE" USING          SD-SOCKET,                  25 JUN96017400                                      WRITE-LEN,                  25 JUN96017500                                      RW-BUFFER,                  25 JUN96017600                                      WS-OPTIONAL-PARMS,          25 JUN96017700                                      WS-ERR-STATUS.              25 JUN96017800                                                                  25 JUN96017900     MOVE "N"                         TO EOF-READ-FLAG.           25 JUN96018000                                                                  26 JUN96018100     IF WS-METHOD (3:1) = "A"                                     26 JUN96018200        MOVE SPACES                   TO WS-OPTIONAL-PARMS        26 JUN96018300        MOVE 5                        TO READ-LEN                 26 JUN96018400        CALL "QSDK_READ" USING        SD-SOCKET,                  26 JUN96018500                                      READ-LEN,                   26 JUN96018600                                      WS-OPTIONAL-PARMS,          26 JUN96018700                                      READ-ACTUAL,                26 JUN96018800                                      RW-BUFFER,                  26 JUN96018900                                      WS-ERR-STATUS               26 JUN96019000        IF WS-ERR-CODE <> ZERO OR                                 26 JUN96019100           RW-BUFFER (1:5) <> "READY"                             26 JUN96019200           MOVE "Y"                      TO EOF-READ-FLAG         26 JUN96019300           DISPLAY "Buffer: ", RW-BUFFER (1:5)                    26 JUN96019400           DISPLAY " Error: ", WS-ERR-CODE                        26 JUN96019500           DISPLAY "Didn't get 'READY'..."                        26 JUN96019600        END-IF                                                    26 JUN96019700     END-IF.                                                      26 JUN96019800                                                                  26 JUN96019900     MOVE ZERO                        TO REC-LEN.                 27 JUN96020000     MOVE SPACES                      TO REC-BUF.                 27 JUN96020100                                                                  27 JUN96020200     PERFORM UNTIL EOF-READ                                       25 JUN96020300       IF WS-METHOD (3:1) = "A"                                   26 JUN96020400          MOVE SPACES                 TO WS-OPTIONAL-PARMS        26 JUN96020500          MOVE 2                      TO WRITE-LEN                26 JUN96020600          MOVE "OK"                   TO RW-BUFFER (1:2)          26 JUN96020700          CALL "QSDK_WRITE" USING     SD-SOCKET,                  26 JUN96020800                                      WRITE-LEN,                  26 JUN96020900                                      RW-BUFFER,                  26 JUN96021000                                      WS-OPTIONAL-PARMS,          26 JUN96021100                                      WS-ERR-STATUS               26 JUN96021200       END-IF                                                     26 JUN96021300                                                                          021400       MOVE SPACES                    TO WS-OPTIONAL-PARMS        25 JUN96021500       MOVE 2048                      TO READ-LEN                 25 JUN96021600                                                                          021700       CALL "QSDK_READ" USING         SD-SOCKET,                  25 JUN96021800                                      READ-LEN,                   25 JUN96021900                                      WS-OPTIONAL-PARMS,          25 JUN96022000                                      READ-ACTUAL,                25 JUN96022100                                      RW-BUFFER,                  25 JUN96022200                                      WS-ERR-STATUS               25 JUN96022300       IF WS-ERR-CODE <> ZERO                                     25 JUN96022400          MOVE "Y"                    TO EOF-READ-FLAG            25 JUN96022500          DISPLAY "   Err code: ", WS-ERR-CODE                    25 JUN96022600          DISPLAY "Err code-ll: ", WS-ERR-LL                      25 JUN96022700          DISPLAY "  Err-ll-id: ", WS-ERR-LL-ID                   25 JUN96022800       ELSE                                                       25 JUN96022900          IF READ-ACTUAL <> 0                                     25 JUN96023000             PERFORM B100-DECODE-DATA                             25 JUN96023100          END-IF                                                  25 JUN96023200       END-IF                                                     25 JUN96023300     END-PERFORM.                                                 25 JUN96023400                                                                  25 JUN96023500 B100-DECODE-DATA.                                                25 JUN96023600*                                                                         023700* you cannot guarantee that records won't span socket reads               023800* so you must be able to parse data such that you can handle              023900* the case where the last record of the read isn't complete               024000* and will be the first part of the next record. of course you            024100* also should not assume the next read will get the entire                024200* record as well.                                                         024300                                                                          024400     DISPLAY "QSDK_READ: ", READ-ACTUAL.                          26 JUN96024500                                                                  26 JUN96024600     IF REC-LEN > ZERO                                            27 JUN96024700        COMPUTE I = WS-REC-LEN - REC-LEN                          27 JUN96024800        IF I <= READ-ACTUAL                                       27 JUN96024900           MOVE RW-BUFFER (1:I)       TO REC-BUF (REC-LEN + 1:I)  27 JUN96025000           ADD I                      TO REC-LEN                  27 JUN96025100           PERFORM B110-PROCESS-REC                               27 JUN96025200           ADD 1                      TO I                        27 JUN96025300        ELSE                                                      27 JUN96025400           MOVE RW-BUFFER (1:READ-ACTUAL)                         27 JUN96025500                              TO REC-BUF (REC-LEN + 1:READ-ACTUAL)27 JUN96025600           ADD READ-ACTUAL            TO REC-LEN                  27 JUN96025700           COMPUTE I = READ-ACTUAL + 1                            27 JUN96025800        END-IF                                                    27 JUN96025900     ELSE                                                         27 JUN96026000        MOVE 1                        TO I                        27 JUN96026100     END-IF.                                                      27 JUN96026200                                                                  27 JUN96026300     MOVE "N"                         TO ALL-FINISHED-FLAG.       27 JUN96026400     PERFORM UNTIL ALL-FINISHED                                   25 JUN96026500       IF I > READ-ACTUAL                                         25 JUN96026600          MOVE "Y"                    TO ALL-FINISHED-FLAG        25 JUN96026700       END-IF                                                     25 JUN96026800       IF NOT ALL-FINISHED                                        25 JUN96026900          MOVE RW-BUFFER (I:2)        TO WS-REC-LEN-X             25 JUN96027000          DISPLAY "RW Rec len: ", WS-REC-LEN                      27 JUN96027100          IF WS-REC-LEN = ZERO                                    25 JUN96027200             MOVE "Y"                 TO ALL-FINISHED-FLAG        25 JUN96027300          ELSE                                                    25 JUN96027400             COMPUTE J = 2 + WS-REC-LEN + I - 1                   27 JUN96027500             IF J <= READ-ACTUAL                                  27 JUN96027600                MOVE RW-BUFFER (I + 2:WS-REC-LEN)                 27 JUN96027700                                      TO REC-BUF (1:WS-REC-LEN)   27 JUN96027800                MOVE WS-REC-LEN       TO REC-LEN                  27 JUN96027900                ADD 2, WS-REC-LEN     TO I                        27 JUN96028000                PERFORM B110-PROCESS-REC                          27 JUN96028100             ELSE                                                 27 JUN96028200                COMPUTE J = READ-ACTUAL - (I + 1)                 27 JUN96028300                MOVE RW-BUFFER (I + 2:J) TO REC-BUF (1:J)         27 JUN96028400                MOVE J                TO REC-LEN                  27 JUN96028500                COMPUTE I = READ-ACTUAL + 1                       27 JUN96028600             END-IF                                               27 JUN96028700          END-IF                                                  25 JUN96028800       END-IF                                                     25 JUN96028900     END-PERFORM.                                                 25 JUN96029000                                                                  27 JUN96029100 B110-PROCESS-REC.                                                27 JUN96029200     DISPLAY "Record len: ", REC-LEN.                             27 JUN96029300*    DISPLAY "    Record: ", REC-BUF (1:REC-LEN).                         029400     MOVE ZERO                        TO REC-LEN.                 27 JUN96